using System;
using System.Runtime.InteropServices;

namespace RFIDForm
{
	/// <summary>
	/// RS232ʐMpNX
	/// </summary>
	/// 

	public class Rs232c
	{
		//VA|[g̐ݒɗp\
		private struct DCB
		{
			public int DCBLength;				//\̂̃TCY
			public int BaudRate;				//{[Cgibpsj̐ݒ
			public int fBitFields;				//rbgPʂ̃tB[h`
			public short wReserved;				//\i0Zbgj
			public short XonLim;				//Xon𑗂obt@oCg̎w
			public short XoffLim;				//Xoffobt@oCgw
			public byte ByteSize;				//1f[^̃rbgw
			public byte Parity;					//peB̕w
			public byte StopBits;				//Xgbvrbgw
			public byte XonChar;				//Xonw
			public byte XoffChar;				//Xoffw
			public byte ErrorChar;				//peBG[̏ꍇɎgw
			public byte EofChar;				//oCi[h̃f[^I
			public byte EvtChar;				//Cxg𐶐镶w

		}
		//^CAEg̐ݒɗp\
		private struct COMMTIMEOUTS
		{
			public int ReadIntervalTimeout;		//̓ǂݍ݂̑҂
			public int ReadTotalTimeoutMultiplier;	//ǂݍ݂̂P̎
			public int ReadTotalTimeoutConstant;	//ǂݍ݂̒萔
			public int WriteTotalTimeoutMultiplier;	//݂̂P̎
			public int WriteTotalTimeoutConstant;	//݂̒萔
		}

		
		private DCB dcb;				//DCB\̂̐錾
		private COMMTIMEOUTS commTimeOuts;		//COMMTIMEOUTS\̂̐錾

		private int hComm;					//nhpϐ̐錾
		private bool openFlag;

		private string port;
		private int baudRate;

		//RXgN^
		public Rs232c(string port, int baudRate)
		{
			this.openFlag = false;
			this.port = port;
			this.baudRate = baudRate;
		}

		//|[gԍݒE擾
		public string Port
		{
			get{return this.port;}
			set{this.port = value;}
		}

		//|[g̏Ԃ擾
		public bool IsOpen
		{
			get{return this.openFlag;}
		}

		//VA|[gJ
		public unsafe bool Open()
		{
			const uint READ_WRITE = 0x80000000  | 0x40000000;		//ǂݏp
			const uint OPEN_EXISTING = 3;							
			
			//|[gJ
			hComm = CreateFile(port, READ_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
			
			if (hComm == -1)
			{
				this.openFlag = false;
				return false;
			}

			//VAʐM̐ݒ
			dcb = new DCB();
			dcb.BaudRate = baudRate;							//]x̎w(9600bps)
			dcb.ByteSize = 8;									//rbg̎wi8rbgj
			dcb.fBitFields = 0;									//eLXg[hARTSȂ
			dcb.Parity = 0;										//peB̐ݒipeBȂj
			dcb.StopBits = 0;						            //Xgbvrbgw(1rbg)
			
			fixed(DCB *d  = &dcb)
			{
				SetCommState(hComm, d);
			}

			//^CAEg̐ݒ
			commTimeOuts.ReadIntervalTimeout = 50;						//S̓ǂݍݑ҂ԁi50msj
			commTimeOuts.ReadTotalTimeoutMultiplier = 0;				//ǂݍ݂̂P̑҂
			commTimeOuts.ReadTotalTimeoutConstant = 50;					//ǂݍ݂̍ŏ҂ԁi50msj
			commTimeOuts.WriteTotalTimeoutMultiplier = 0;				//݂̂P̑҂
			commTimeOuts.WriteTotalTimeoutConstant = 50;				//݂̍ŏ҂ԁi50msj
			fixed(COMMTIMEOUTS *comm = &commTimeOuts)	
			{
				SetCommTimeouts(hComm, comm);				
			}
			this.openFlag = true;
			return true; 
		}
		
		//VA|[g
		public void Close()
		{
			CloseHandle(hComm);      
			this.openFlag = false;
			return;
		}

		//VA|[gɃf[^o
		public unsafe bool WriteBytes(byte [] txBytes)
		{
			byte [] txData = txBytes;
			bool txFlag;												
			int txLen = 0;				
			
			fixed (byte* p = txData)
			{
				txFlag = WriteFile(hComm, p, txData.Length, &txLen, 0);

				if(!(txFlag))
				{
					return false;
				}
			}
			return true;
		}

		//VA|[gf[^ǂݍ
		public unsafe bool ReadBytes(ref byte [] rxBytes)
		{	
			//Mf[^
			byte [] rxData = new byte[rxBytes.Length];				
			//Mꂽf[^
			int rxLen = 0;											
			//ReadFile̖߂l
			bool rxFlag;											
			
			fixed (byte* p = rxData)
			{
				rxFlag = ReadFile(hComm, p , rxData.Length , &rxLen, 0);
			
				if(!(rxFlag))
				{
					return false;						
				}
			}	
			if(rxLen == 0 || rxData[0] == 0)
				return false;

			rxBytes = rxData;
			return true;
		}

		#region DllImport̐錾
		[DllImport("kernel32", SetLastError=true)]
		static extern unsafe int CreateFile(string lpFileName, uint dwDesiredAccess, uint dwShareMode,	
			uint lpSecurityAttributes /*really SecurityAttributes pointer*/, uint dwCreationDisposition, 
			uint dwFlagsAndAttributes, uint hTemplateFile);
		
		[DllImport("kernel32", SetLastError=true)]
		static extern unsafe bool ReadFile(int hFile, void* lpBuffer, int nBytesToRead, int* nBytesRead, int lpOverlapped);
		
		[DllImport("kernel32", SetLastError=true)]
		static extern unsafe bool WriteFile(int hFile, void* lpBuffer, int nBytesToWrite, int* nBytesWrite,int lpOverlapped);

		[DllImport("kernel32", SetLastError=true)]
		static extern unsafe int CloseHandle(int hObject);
	
		[DllImport("kernel32", SetLastError=true)]
		static extern unsafe int SetCommState(int hCommDev, DCB* lpDCB);
		
		[DllImport("kernel32", SetLastError=true)]
		static extern unsafe int SetCommTimeouts(int hCommDev, COMMTIMEOUTS* lpCommTimeouts);
		#endregion

	}
}
